<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:tei="http://www.tei-c.org/ns/1.0">
    <xsl:template match="/">
        <html>
        <xsl:apply-templates mode="tree"/>
            </html>
    </xsl:template>
    <xsl:template match="*" mode="tree">
        <div class="indent">
            <span class="markup">&lt;</span>
            <span class="start-tag"><xsl:value-of select="name(.)"/></span>
            <xsl:apply-templates select="@*" mode="tree"/>
            <xsl:choose>
                <xsl:when test="string-length(.) = 0">
                <span class="markup">/&gt;</span>
                </xsl:when>
                <xsl:otherwise>
            <span class="markup">&gt;</span>
            <span class="text"><xsl:value-of select="."/></span>
            
            <span class="markup">&lt;/</span>
            <span class="end-tag"><xsl:value-of select="name(.)"/></span>
            <span class="markup">&gt;</span>
                    
                </xsl:otherwise>
            </xsl:choose>
            
        </div>
    </xsl:template>
    <xsl:template match="tei:*/@TEIform"/>
    <!--
    <xsl:template match="*[node()]" mode="tree">
        <div class="indent">
            <span class="markup">&lt;</span>
            <span class="start-tag"><xsl:value-of select="name(.)"/></span>
            <xsl:apply-templates select="@*" mode="tree"/>
            <span class="markup">&gt;</span>
            
            <span class="text"><xsl:value-of select="."/></span>
            
            <span class="markup">&lt;/</span>
            <span class="end-tag"><xsl:value-of select="name(.)"/></span>
            <span class="markup">&gt;</span>
        </div>
    </xsl:template>
    -->
    <xsl:template match="*[* or processing-instruction() or comment() or string-length(.) &gt; 50]" mode="tree">
        <table>
            <tr>
                <xsl:call-template name="expander"/>
                <td>
                    <span class="markup">&lt;</span>
                    <span class="start-tag"><xsl:value-of select="name(.)"/></span>
                    <xsl:apply-templates select="@*" mode="tree"/>
                    <span class="markup">&gt;</span>
                    
                    <div class="expander-content"><xsl:apply-templates mode="tree"/></div>
                    
                    <span class="markup">&lt;/</span>
                    <span class="end-tag"><xsl:value-of select="name(.)"/></span>
                    <span class="markup">&gt;</span>
                </td>
            </tr>
        </table>
    </xsl:template>
    
    <xsl:template match="@*" mode="tree">
        <xsl:text> </xsl:text>
        <span class="attribute-name"><xsl:value-of select="name(.)"/></span>
        <span class="markup">=</span>
        <span class="attribute-value">"<xsl:value-of select="."/>"</span>
    </xsl:template>
    
    <xsl:template match="text()" mode="tree">
        <xsl:if test="normalize-space(.)">
            <div class="indent text"><xsl:value-of select="."/></div>
        </xsl:if>
    </xsl:template>
    
    <xsl:template match="processing-instruction()" mode="tree">
        <div class="indent pi">
            <xsl:text>&lt;?</xsl:text>
            <xsl:value-of select="name(.)"/>
            <xsl:text> </xsl:text>
            <xsl:value-of select="."/>
            <xsl:text>?&gt;</xsl:text>
        </div>
    </xsl:template>

    <xsl:template match="processing-instruction()[string-length(.) &gt; 50]" mode="tree">
        <table>
            <tr>
                <xsl:call-template name="expander"/>
                <td class="pi">
                    &lt;?<xsl:value-of select="name(.)"/>
                    <div class="indent expander-content"><xsl:value-of select="."/></div>
                    <xsl:text>?&gt;</xsl:text>
                </td>
            </tr>
        </table>
    </xsl:template>

    <xsl:template match="comment()" mode="tree">
        <div class="comment indent">
            <xsl:text>&lt;!--</xsl:text>
            <xsl:value-of select="."/>
            <xsl:text>--&gt;</xsl:text>
        </div>
    </xsl:template>
    
    <xsl:template match="comment()[string-length(.) &gt; 50]" mode="tree">
        <table>
            <tr>
                <xsl:call-template name="expander"/>
                <td class="comment">
                    <xsl:text>&lt;!--</xsl:text>
                    <div class="indent expander-content"><xsl:value-of select="."/></div>
                    <xsl:text>--&gt;</xsl:text>
                </td>
            </tr>
        </table>
    </xsl:template>
    
    <xsl:template name="expander">
        <td class="expander"> <div class="spacer"/></td>
    </xsl:template>
    
</xsl:stylesheet>
